#include <stdio.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <math.h>

int main(int n, char **v)
{
  char *infile;
  char *outfile;
  FILE *f;
  struct stat s;
  float *data;
  float *max;
  ssize_t size;
  ssize_t i;
  float gain;
  int up;
  float last;

  if (n != 3) {
    printf("gimme <input float mono file> <output float mono file>\n");
    return 1;
  }

  infile = v[1];
  outfile = v[2];

  if (stat(infile, &s)) { perror(infile); return 1; }
  size = s.st_size;

  data = malloc(size * sizeof(float)); if (data == NULL) abort();
  max = malloc(size * sizeof(float)); if (max == NULL) abort();

  f = fopen(infile, "rb"); if (f == NULL) { perror(infile); return 1; }
  fread(data, size, 4, f);
  fclose(f);

  max[size-1] = fabsf(data[size-1]);

  /* populate max */
  for (i = size-2; i >= 0; i--) {
    float m = fabsf(data[i]);
    if (m > max[i+1]) max[i] = m; else max[i] = max[i+1];
  }

  /* apply gain */
  gain = 1;
  up = 1;
  last = data[0];
  for (i = 0; i < size; i++) {
    data[i] *= gain;
    max[i] *= gain;
    if (up == 0 && data[i] > last) {
      /* local minimum */
      if (max[i] <= 0.5) gain *= 2;
    }
    if (data[i] > last) up = 1;
    else if (data[i] < last) up = 0;
    last = data[i];
  }

  f = fopen(outfile, "wb"); if (f == NULL) { perror(outfile); return 1; }
  fwrite(data, size, 4, f);
  fclose(f);

  return 0;
}
