/* generated by gtkcooker (http://sed.free.fr/gtkcooker) */

#include "editor.h"




#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <sndfile.h>
#include <errno.h>
#include <math.h>
#include <stdarg.h>
#include <portaudio.h>
#ifdef WIN32
#include <windows.h>
#endif

gui g;
file_loader f;
int fchoice;

void status(char *f, ...)
{
  char z[65536]; z[65535] = 0;
  va_list l;
  va_start(l, f);
  vsnprintf(z, 65535, f, l);
  va_end(l);
  gtk_label_set_text(GTK_LABEL(g.info), z);
}

void set_nlen(int i, int v)
{
  char s[64];
  sprintf(s, "%2d", v);
  switch (i) {
#include "set_nlen.c"
  }
}

void set_len(int i, int v, int hz)
{
  char s[64];
  sprintf(s, "%7d (%d Hz)", v, hz);
  switch (i) {
#include "set_len.c"
  }
}

const char *get_t(int i)
{
  switch (i) {
#include "get_t.c"
  }
  return NULL;
}

void set_t(int i, const char *v)
{
  switch (i) {
#include "set_t.c"
  }
}

const char *get_n(int i)
{
  switch (i) {
#include "get_n.c"
  }
  return NULL;
}

void set_n(int i, const char *v)
{
  switch (i) {
#include "set_n.c"
  }
}

void choose(int i)
{
  fchoice = i + 100;
  gtk_widget_show_all(f.f);
}

unsigned char audio[1024*1024];
unsigned char code[32768];
uint16_t offset[49];

#define BIT(x,n) (((x)>>(n))&1)

#define BITSWAP16(val,B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0) \
        ((BIT(val,B15) << 15) | (BIT(val,B14) << 14) | (BIT(val,B13) << 13) | (BIT(val,B12) << 12) | \
                (BIT(val,B11) << 11) | (BIT(val,B10) << 10) | (BIT(val, B9) <<  9) | (BIT(val, B8) <<  8) | \
                (BIT(val, B7) <<  7) | (BIT(val, B6) <<  6) | (BIT(val, B5) <<  5) | (BIT(val, B4) <<  4) | \
                (BIT(val, B3) <<  3) | (BIT(val, B2) <<  2) | (BIT(val, B1) <<  1) | (BIT(val, B0) <<  0))

int load_code(const char *file)
{
  unsigned char cc[32768];
  int i;
  FILE *f = fopen(file, "rb");
  if (!f) { status("ERROR: %s: %s", file, strerror(errno)); return -1; }
  fread(cc, 32768, 1, f);
  fclose(f);
  for (i = 0; i < 32768; i++) {
    code[BITSWAP16(i,15,14,13,12,11,10,9,8,0,1,2,3,4,5,6,7)] = cc[i];
  }
  return 0;
}

int save_code(const char *file)
{
  unsigned char cc[32768];
  int i;
  FILE *f;
  for (i = 0; i < 32768; i++) {
    cc[i] = code[BITSWAP16(i,15,14,13,12,11,10,9,8,0,1,2,3,4,5,6,7)];
  }
  f = fopen(file, "wb");
  if (!f) { status("ERROR: %s: %s", file, strerror(errno)); return -1; }
  fwrite(cc, 32768, 1, f);
  fclose(f);
  return 0;
}

void put_audio(long pos, unsigned char v)
{
  if (pos >= 1024*1024) { status("ERROR: audio full\n"); return; }
  audio[pos] = v;
}

long load_sample(int n, long loadpos)
{
  const char *name;
  SF_INFO inf;
  SNDFILE *f;
  float *buf;
  float *max;
  sf_count_t c;
  int i;
  float gain;
  int update_view = loadpos == 0;

  name = get_t(n);
  if (strlen(name) == 0) return -2;

  inf.format = 0;
  f = sf_open(name, SFM_READ, &inf);
  if (f == NULL)
    { status("ERROR: cannot open audio file %s", name); return -1; }
  if (inf.channels != 1) {
    status("ERROR: %s: %d channels, only 1 is supported\n", name, inf.channels);
    sf_close(f);
    return -1;
  }
  printf("INFO: %s is at %d Hz (stored at 0x%4.4lx)\n", name, inf.samplerate,
         loadpos);

  buf = malloc(sizeof(float) * inf.frames); if (buf == NULL) abort();
  max = malloc(sizeof(float) * inf.frames); if (max == NULL) abort();

  c = sf_read_float(f, buf, inf.frames);
  if (c != inf.frames) { status("ERROR: %s: read error\n", name);
    sf_close(f); free(buf); free(max); return -1; }
  sf_close(f);

  max[inf.frames-1] = fabsf(buf[inf.frames-1]);
  for (i = inf.frames-2; i >= 0; i--) {
    if (max[i+1] > fabsf(buf[i])) max[i] = max[i+1];
    else                          max[i] = fabsf(buf[i]);
  }

  gain = 1;
  for (i = 0; i < inf.frames-1; i++) {
    float v;
    max[i] *= gain;
    if (max[i] <= 0.5 && gain != 256)
      { put_audio(loadpos, 0x80); loadpos++; gain *= 2; }
    v = buf[i] * gain * 127;
    if (v < -127) v = -127;
    if (v > 127)  v = 127;
    put_audio(loadpos, lrint(v));
    loadpos++;
  }

  /* end marker */
  put_audio(loadpos, 0x80); loadpos++;
  put_audio(loadpos, 0x80); loadpos++;
  put_audio(loadpos, 0x80); loadpos++;
  while (loadpos & 15) { put_audio(loadpos, 0x80); loadpos++; }

  free(buf);
  free(max);

  if (update_view) set_len(n, loadpos, inf.samplerate);

  return loadpos;
}

int compute(void)
{
  int i;
  long len = 0;

  for (i = 0; i < 49; i++) {
    long z = load_sample(i, 0);
    if (z == -1) return -1;
    if (z == -2) continue;
    len += z;
  }

  if (len > 1024*1024) {
    status("ERROR: too much audio data length=%ld (max is 1048576)", len);
    return -1;
  } else
    status("OK audio length %ld (max is 1048576) (free space %ld)", len, 1048576-len);
  return 0;
}

void save(void)
{
  const char *romcode = gtk_entry_get_text(GTK_ENTRY(g.tc));
  const char *romaudio1 = gtk_entry_get_text(GTK_ENTRY(g.ta1));
  const char *romaudio2 = gtk_entry_get_text(GTK_ENTRY(g.ta2));
  long pos;
  int i;
  FILE *f;

  if (compute() == -1) return;

  for (i = 0; i < 49; i++) offset[i] = 0;

  pos = 0;
  for (i = 0; i < 49; i++) {
    long z;
    z = load_sample(i, pos);
    if (z == -1) return;
    if (z == -2) continue;
    offset[i] = pos >> 4;
    pos = z;
  }

  /* save audio ROMs */
  f = fopen(romaudio1, "wb");
  if (f == NULL)
    { status("ERROR: %s: %s", romaudio1, strerror(errno)); return; }
  if (fwrite(audio, 512*1024, 1, f) != 1)
    { status("ERROR: %s: %s", romaudio1, strerror(errno)); fclose(f); return; }
  if (fclose(f))
    { status("ERROR: %s: %s", romaudio1, strerror(errno)); return; }
  f = fopen(romaudio2, "wb");
  if (f == NULL)
    { status("ERROR: %s: %s", romaudio2, strerror(errno)); return; }
  if (fwrite(audio+512*1024, 512*1024, 1, f) != 1)
    { status("ERROR: %s: %s", romaudio2, strerror(errno)); fclose(f); return; }
  if (fclose(f))
    { status("ERROR: %s: %s", romaudio2, strerror(errno)); return; }

  /* update code ROM */
  if (load_code(romcode) == -1) return;
  for (i = 0; i < 49; i++) {
    unsigned char *b = code + 0x6bfd + i * 2;
    b[0] = (offset[i] >> 8) & 255;
    b[1] = offset[i] & 255;
  }
  for (i = 0; i < 49; i++) {
    unsigned char *b = code + 0x6bfd + 49 * 2 + i * 16;
    const char *name = get_n(i);
    int j;
    for (j = 0; j < 16; j++) b[j] = ' ';
    for (j = 0; j < 16 && j < strlen(name); j++) b[j] = name[j];
  }
  if (save_code(romcode) == -1) return;

  status("OK ROMs saved");
}

void quit(void)
{
  gtk_main_quit();
}

#define BLOCKSIZE 4096
void play(int i)
{
  unsigned char buf[BLOCKSIZE];
  PaError err;
  PaStreamParameters outputParameters;
  int NUM_CHANNELS;
  int SAMPLE_RATE;
  int FRAMES_PER_BUFFER;
  PaStream *stream;

  const char *name;
  SF_INFO inf;
  SNDFILE *f;
  sf_count_t c;

  name = get_t(i);
  if (strlen(name) == 0) { status("ERROR: no file to play"); return; }
  inf.format = 0;
  f = sf_open(name, SFM_READ, &inf);
  if (f == NULL)
    { status("ERROR: cannot open audio file %s", name); return; }

  NUM_CHANNELS = inf.channels;
  SAMPLE_RATE = inf.samplerate;
  FRAMES_PER_BUFFER = BLOCKSIZE / 2 / NUM_CHANNELS;

  /* -- initialize PortAudio -- */
  err = Pa_Initialize();
  if( err != paNoError ) goto error;

{
  PaDeviceIndex n = Pa_GetDeviceCount();
  PaDeviceIndex i;
  for (i = 0; i < n; i++) {
    const PaDeviceInfo *v = Pa_GetDeviceInfo(i);
    printf("%d: %s\n", i, v->name);
  }
  printf("default: %d\n", Pa_GetDefaultOutputDevice());

  n = Pa_GetHostApiCount();
  for (i = 0; i < n; i++) {
    const PaHostApiInfo *v = Pa_GetHostApiInfo(i);
    printf("%d: %s\n", i, v->name);
  }
}

  /* -- setup output -- */
  outputParameters.device = Pa_GetDefaultOutputDevice(); /* default output device */
  outputParameters.channelCount = NUM_CHANNELS;
  outputParameters.sampleFormat = paInt16;
  outputParameters.suggestedLatency = Pa_GetDeviceInfo( outputParameters.device )->defaultHighOutputLatency;
  outputParameters.hostApiSpecificStreamInfo = NULL;

  /* -- setup stream -- */
  err = Pa_OpenStream(
            &stream,
            NULL,
            &outputParameters,
            SAMPLE_RATE,
            FRAMES_PER_BUFFER,
            paClipOff, /* we won't output out of range samples so don't bother clipping them */
            NULL, /* no callback, use blocking API */
            NULL ); /* no callback, so no callback userData */
  if( err != paNoError ) goto error;

  /* -- start stream -- */
  err = Pa_StartStream( stream );
  if( err != paNoError ) goto error;

  /* -- Here's the loop where we pass data from input to output -- */
  while (1) {
    c = sf_read_short(f, (short*)buf, FRAMES_PER_BUFFER);
    if (c <= 0) break;
    if (c != FRAMES_PER_BUFFER)
      memset(buf + c * 2 * NUM_CHANNELS,
             0, (FRAMES_PER_BUFFER - c) * 2 * NUM_CHANNELS);
    err = Pa_WriteStream( stream, buf, FRAMES_PER_BUFFER );
    if( err ) goto xrun;
  }

  /* -- Now we stop the stream -- */
  err = Pa_StopStream( stream );
  if( err != paNoError ) goto error;

  /* -- don't forget to cleanup! -- */
  err = Pa_CloseStream( stream );
  if( err != paNoError ) goto error;
  Pa_Terminate();
  sf_close(f);
  return;

error:;
xrun:
  Pa_Terminate();
  sf_close(f);
  status("ERROR: audio error somewhere...");

#if 0
#ifdef WIN32
  PlaySound(NULL, NULL, 0);
  status("Play %d", PlaySound(get_t(i), NULL, SND_FILENAME | SND_ASYNC | SND_NODEFAULT));
#endif
#endif
}

void load(int i)
{
  fchoice = i;
  gtk_widget_show_all(f.f);
}

char *state_file;

void state_save(void)
{
  FILE *f = fopen(state_file, "wb"); if (f == NULL) abort();
  int i;
  for (i = 0; i < 49; i++) fprintf(f, "%s\n%s\n", get_n(i), get_t(i));
  fprintf(f, "%s\n", gtk_entry_get_text(GTK_ENTRY(g.ta1)));
  fprintf(f, "%s\n", gtk_entry_get_text(GTK_ENTRY(g.ta2)));
  fprintf(f, "%s\n", gtk_entry_get_text(GTK_ENTRY(g.tc)));
  fclose(f);
}

void state_load(void)
{
  FILE *f = fopen(state_file, "rb"); if (f == NULL) return;
  char *l = malloc(200000); if (!l) abort();
  int i, n;
  for (i = 0; i < 49; i++) {
    fgets(l, 200000, f); n = strlen(l); if (n && l[n-1] == '\n') l[n-1] = 0;
    set_n(i, l);
    fgets(l, 200000, f); n = strlen(l); if (n && l[n-1] == '\n') l[n-1] = 0;
    set_t(i, l);
  }
  fgets(l, 200000, f); n = strlen(l); if (n && l[n-1] == '\n') l[n-1] = 0;
  gtk_entry_set_text(GTK_ENTRY(g.ta1), l);
  gtk_editable_set_position(GTK_EDITABLE(g.ta1), -1);
  fgets(l, 200000, f); n = strlen(l); if (n && l[n-1] == '\n') l[n-1] = 0;
  gtk_entry_set_text(GTK_ENTRY(g.ta2), l);
  gtk_editable_set_position(GTK_EDITABLE(g.ta2), -1);
  fgets(l, 200000, f); n = strlen(l); if (n && l[n-1] == '\n') l[n-1] = 0;
  gtk_entry_set_text(GTK_ENTRY(g.tc), l);
  gtk_editable_set_position(GTK_EDITABLE(g.tc), -1);
  fclose(f);
  free(l);
}

void n_changed(GtkEditable *e, void *_i)
{
  int i = (intptr_t)_i;
  set_nlen(i, strlen(gtk_entry_get_text(GTK_ENTRY(e))));
  state_save();
}

int main(int n, char **v)
{
#ifdef WIN32
  state_file = strdup(v[0]); if (state_file == NULL) abort();
  if (strlen(state_file) < 3) abort();
  state_file[strlen(state_file) - 3] = 't';
  state_file[strlen(state_file) - 2] = 'x';
  state_file[strlen(state_file) - 1] = 't';
#else
  state_file = malloc(strlen(v[0])+5); if (state_file == NULL) abort();
  sprintf(state_file, "%s.txt", v[0]);
#endif

  gtk_init(0, 0);
  init_gui(&g);
  init_file_loader(&f);

  state_load();
  compute();

#include "name_changed.c"
#include "t_changed.c"
  g_signal_connect(g.ta1, "changed", (GCallback)state_save, NULL);
  g_signal_connect(g.ta2, "changed", (GCallback)state_save, NULL);
  g_signal_connect(g.tc, "changed", (GCallback)state_save, NULL);

  gtk_widget_show_all(g.mw);
  gtk_main();
  return 0;
}




void _ok(GtkWidget *f, const char *filename)
{
  gtk_widget_hide(f);
  if (fchoice < 100) { set_t(fchoice, filename); compute(); return; }
  switch (fchoice - 100) {
  case 0: gtk_entry_set_text(GTK_ENTRY(g.ta1), filename);
          gtk_editable_set_position(GTK_EDITABLE(g.ta1), -1);  break;
  case 1: gtk_entry_set_text(GTK_ENTRY(g.ta2), filename);
          gtk_editable_set_position(GTK_EDITABLE(g.ta2), -1);  break;
  case 2: gtk_entry_set_text(GTK_ENTRY(g.tc), filename);
          gtk_editable_set_position(GTK_EDITABLE(g.tc), -1);  break;
  }
}

void _cancel(GtkWidget *f)
{
  gtk_widget_hide(f);
}


static gboolean _1(GtkWidget *_widget, GdkEvent *_event, gui *this)
{
{gtk_main_quit();}
  return TRUE;
}

static void _3(GtkButton *_widget, gui *this)
{
  {play(0);}
}

static void _5(GtkButton *_widget, gui *this)
{
  {load(0);}
}

static void _7(GtkButton *_widget, gui *this)
{
  {play(1);}
}

static void _9(GtkButton *_widget, gui *this)
{
  {load(1);}
}

static void _11(GtkButton *_widget, gui *this)
{
  {play(2);}
}

static void _13(GtkButton *_widget, gui *this)
{
  {load(2);}
}

static void _15(GtkButton *_widget, gui *this)
{
  {play(3);}
}

static void _17(GtkButton *_widget, gui *this)
{
  {load(3);}
}

static void _19(GtkButton *_widget, gui *this)
{
  {play(4);}
}

static void _21(GtkButton *_widget, gui *this)
{
  {load(4);}
}

static void _23(GtkButton *_widget, gui *this)
{
  {play(5);}
}

static void _25(GtkButton *_widget, gui *this)
{
  {load(5);}
}

static void _27(GtkButton *_widget, gui *this)
{
  {play(6);}
}

static void _29(GtkButton *_widget, gui *this)
{
  {load(6);}
}

static void _31(GtkButton *_widget, gui *this)
{
  {play(7);}
}

static void _33(GtkButton *_widget, gui *this)
{
  {load(7);}
}

static void _35(GtkButton *_widget, gui *this)
{
  {play(8);}
}

static void _37(GtkButton *_widget, gui *this)
{
  {load(8);}
}

static void _39(GtkButton *_widget, gui *this)
{
  {play(9);}
}

static void _41(GtkButton *_widget, gui *this)
{
  {load(9);}
}

static void _43(GtkButton *_widget, gui *this)
{
  {play(10);}
}

static void _45(GtkButton *_widget, gui *this)
{
  {load(10);}
}

static void _47(GtkButton *_widget, gui *this)
{
  {play(11);}
}

static void _49(GtkButton *_widget, gui *this)
{
  {load(11);}
}

static void _51(GtkButton *_widget, gui *this)
{
  {play(12);}
}

static void _53(GtkButton *_widget, gui *this)
{
  {load(12);}
}

static void _55(GtkButton *_widget, gui *this)
{
  {play(13);}
}

static void _57(GtkButton *_widget, gui *this)
{
  {load(13);}
}

static void _59(GtkButton *_widget, gui *this)
{
  {play(14);}
}

static void _61(GtkButton *_widget, gui *this)
{
  {load(14);}
}

static void _63(GtkButton *_widget, gui *this)
{
  {play(15);}
}

static void _65(GtkButton *_widget, gui *this)
{
  {load(15);}
}

static void _67(GtkButton *_widget, gui *this)
{
  {play(16);}
}

static void _69(GtkButton *_widget, gui *this)
{
  {load(16);}
}

static void _71(GtkButton *_widget, gui *this)
{
  {play(17);}
}

static void _73(GtkButton *_widget, gui *this)
{
  {load(17);}
}

static void _75(GtkButton *_widget, gui *this)
{
  {play(18);}
}

static void _77(GtkButton *_widget, gui *this)
{
  {load(18);}
}

static void _79(GtkButton *_widget, gui *this)
{
  {play(19);}
}

static void _81(GtkButton *_widget, gui *this)
{
  {load(19);}
}

static void _83(GtkButton *_widget, gui *this)
{
  {play(20);}
}

static void _85(GtkButton *_widget, gui *this)
{
  {load(20);}
}

static void _87(GtkButton *_widget, gui *this)
{
  {play(21);}
}

static void _89(GtkButton *_widget, gui *this)
{
  {load(21);}
}

static void _91(GtkButton *_widget, gui *this)
{
  {play(22);}
}

static void _93(GtkButton *_widget, gui *this)
{
  {load(22);}
}

static void _95(GtkButton *_widget, gui *this)
{
  {play(23);}
}

static void _97(GtkButton *_widget, gui *this)
{
  {load(23);}
}

static void _99(GtkButton *_widget, gui *this)
{
  {play(24);}
}

static void _101(GtkButton *_widget, gui *this)
{
  {load(24);}
}

static void _103(GtkButton *_widget, gui *this)
{
  {play(25);}
}

static void _105(GtkButton *_widget, gui *this)
{
  {load(25);}
}

static void _107(GtkButton *_widget, gui *this)
{
  {play(26);}
}

static void _109(GtkButton *_widget, gui *this)
{
  {load(26);}
}

static void _111(GtkButton *_widget, gui *this)
{
  {play(27);}
}

static void _113(GtkButton *_widget, gui *this)
{
  {load(27);}
}

static void _115(GtkButton *_widget, gui *this)
{
  {play(28);}
}

static void _117(GtkButton *_widget, gui *this)
{
  {load(28);}
}

static void _119(GtkButton *_widget, gui *this)
{
  {play(29);}
}

static void _121(GtkButton *_widget, gui *this)
{
  {load(29);}
}

static void _123(GtkButton *_widget, gui *this)
{
  {play(30);}
}

static void _125(GtkButton *_widget, gui *this)
{
  {load(30);}
}

static void _127(GtkButton *_widget, gui *this)
{
  {play(31);}
}

static void _129(GtkButton *_widget, gui *this)
{
  {load(31);}
}

static void _131(GtkButton *_widget, gui *this)
{
  {play(32);}
}

static void _133(GtkButton *_widget, gui *this)
{
  {load(32);}
}

static void _135(GtkButton *_widget, gui *this)
{
  {play(33);}
}

static void _137(GtkButton *_widget, gui *this)
{
  {load(33);}
}

static void _139(GtkButton *_widget, gui *this)
{
  {play(34);}
}

static void _141(GtkButton *_widget, gui *this)
{
  {load(34);}
}

static void _143(GtkButton *_widget, gui *this)
{
  {play(35);}
}

static void _145(GtkButton *_widget, gui *this)
{
  {load(35);}
}

static void _147(GtkButton *_widget, gui *this)
{
  {play(36);}
}

static void _149(GtkButton *_widget, gui *this)
{
  {load(36);}
}

static void _151(GtkButton *_widget, gui *this)
{
  {play(37);}
}

static void _153(GtkButton *_widget, gui *this)
{
  {load(37);}
}

static void _155(GtkButton *_widget, gui *this)
{
  {play(38);}
}

static void _157(GtkButton *_widget, gui *this)
{
  {load(38);}
}

static void _159(GtkButton *_widget, gui *this)
{
  {play(39);}
}

static void _161(GtkButton *_widget, gui *this)
{
  {load(39);}
}

static void _163(GtkButton *_widget, gui *this)
{
  {play(40);}
}

static void _165(GtkButton *_widget, gui *this)
{
  {load(40);}
}

static void _167(GtkButton *_widget, gui *this)
{
  {play(41);}
}

static void _169(GtkButton *_widget, gui *this)
{
  {load(41);}
}

static void _171(GtkButton *_widget, gui *this)
{
  {play(42);}
}

static void _173(GtkButton *_widget, gui *this)
{
  {load(42);}
}

static void _175(GtkButton *_widget, gui *this)
{
  {play(43);}
}

static void _177(GtkButton *_widget, gui *this)
{
  {load(43);}
}

static void _179(GtkButton *_widget, gui *this)
{
  {play(44);}
}

static void _181(GtkButton *_widget, gui *this)
{
  {load(44);}
}

static void _183(GtkButton *_widget, gui *this)
{
  {play(45);}
}

static void _185(GtkButton *_widget, gui *this)
{
  {load(45);}
}

static void _187(GtkButton *_widget, gui *this)
{
  {play(46);}
}

static void _189(GtkButton *_widget, gui *this)
{
  {load(46);}
}

static void _191(GtkButton *_widget, gui *this)
{
  {play(47);}
}

static void _193(GtkButton *_widget, gui *this)
{
  {load(47);}
}

static void _195(GtkButton *_widget, gui *this)
{
  {play(48);}
}

static void _197(GtkButton *_widget, gui *this)
{
  {load(48);}
}

static void _199(GtkButton *_widget, gui *this)
{
  {choose(0);}
}

static void _201(GtkButton *_widget, gui *this)
{
  {choose(1);}
}

static void _203(GtkButton *_widget, gui *this)
{
  {choose(2);}
}

static void _205(GtkButton *_widget, gui *this)
{
  {compute();}
}

static void _207(GtkButton *_widget, gui *this)
{
  {save();}
}

static void _209(GtkButton *_widget, gui *this)
{
  {quit();}
}

/* returns -1 on error, 0 if everything is fine */
int init_gui(gui *this)
{
  GtkWidget *_0;
  GtkWidget *_267;
  GtkWidget *_2;
  GtkWidget *_4;
  GtkWidget *_6;
  GtkWidget *_8;
  GtkWidget *_10;
  GtkWidget *_12;
  GtkWidget *_14;
  GtkWidget *_16;
  GtkWidget *_18;
  GtkWidget *_20;
  GtkWidget *_22;
  GtkWidget *_24;
  GtkWidget *_26;
  GtkWidget *_28;
  GtkWidget *_30;
  GtkWidget *_32;
  GtkWidget *_34;
  GtkWidget *_36;
  GtkWidget *_38;
  GtkWidget *_40;
  GtkWidget *_42;
  GtkWidget *_44;
  GtkWidget *_46;
  GtkWidget *_48;
  GtkWidget *_50;
  GtkWidget *_52;
  GtkWidget *_54;
  GtkWidget *_56;
  GtkWidget *_58;
  GtkWidget *_60;
  GtkWidget *_62;
  GtkWidget *_64;
  GtkWidget *_66;
  GtkWidget *_68;
  GtkWidget *_70;
  GtkWidget *_72;
  GtkWidget *_74;
  GtkWidget *_76;
  GtkWidget *_78;
  GtkWidget *_80;
  GtkWidget *_82;
  GtkWidget *_84;
  GtkWidget *_86;
  GtkWidget *_88;
  GtkWidget *_90;
  GtkWidget *_92;
  GtkWidget *_94;
  GtkWidget *_96;
  GtkWidget *_98;
  GtkWidget *_100;
  GtkWidget *_102;
  GtkWidget *_104;
  GtkWidget *_106;
  GtkWidget *_108;
  GtkWidget *_110;
  GtkWidget *_112;
  GtkWidget *_114;
  GtkWidget *_116;
  GtkWidget *_118;
  GtkWidget *_120;
  GtkWidget *_122;
  GtkWidget *_124;
  GtkWidget *_126;
  GtkWidget *_128;
  GtkWidget *_130;
  GtkWidget *_132;
  GtkWidget *_134;
  GtkWidget *_136;
  GtkWidget *_138;
  GtkWidget *_140;
  GtkWidget *_142;
  GtkWidget *_144;
  GtkWidget *_146;
  GtkWidget *_148;
  GtkWidget *_150;
  GtkWidget *_152;
  GtkWidget *_154;
  GtkWidget *_156;
  GtkWidget *_158;
  GtkWidget *_160;
  GtkWidget *_162;
  GtkWidget *_164;
  GtkWidget *_166;
  GtkWidget *_168;
  GtkWidget *_170;
  GtkWidget *_172;
  GtkWidget *_174;
  GtkWidget *_176;
  GtkWidget *_178;
  GtkWidget *_180;
  GtkWidget *_182;
  GtkWidget *_184;
  GtkWidget *_186;
  GtkWidget *_188;
  GtkWidget *_190;
  GtkWidget *_192;
  GtkWidget *_194;
  GtkWidget *_196;
  GtkWidget *_198;
  GtkWidget *_200;
  GtkWidget *_202;
  GtkWidget *_204;
  GtkWidget *_206;
  GtkWidget *_208;
  GtkWidget *_210;
  GtkWidget *_211;
  GtkWidget *_212;
  GtkWidget *_213;
  GtkWidget *_214;
  GtkWidget *_215;
  GtkWidget *_216;
  GtkWidget *_217;
  GtkWidget *_218;
  GtkWidget *_219;
  GtkWidget *_220;
  GtkWidget *_221;
  GtkWidget *_222;
  GtkWidget *_223;
  GtkWidget *_224;
  GtkWidget *_225;
  GtkWidget *_226;
  GtkWidget *_227;
  GtkWidget *_228;
  GtkWidget *_229;
  GtkWidget *_230;
  GtkWidget *_231;
  GtkWidget *_232;
  GtkWidget *_233;
  GtkWidget *_234;
  GtkWidget *_235;
  GtkWidget *_236;
  GtkWidget *_237;
  GtkWidget *_238;
  GtkWidget *_239;
  GtkWidget *_240;
  GtkWidget *_241;
  GtkWidget *_242;
  GtkWidget *_243;
  GtkWidget *_244;
  GtkWidget *_245;
  GtkWidget *_246;
  GtkWidget *_247;
  GtkWidget *_248;
  GtkWidget *_249;
  GtkWidget *_250;
  GtkWidget *_251;
  GtkWidget *_252;
  GtkWidget *_253;
  GtkWidget *_254;
  GtkWidget *_255;
  GtkWidget *_256;
  GtkWidget *_257;
  GtkWidget *_258;
  GtkWidget *_259;
  GtkWidget *_260;
  GtkWidget *_261;
  GtkWidget *_262;
  GtkWidget *_263;
  GtkWidget *_264;
  GtkWidget *_265;
  GtkWidget *_266;
  GtkWidget *_268;

  this->mw = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request(this->mw, -1, 500);
  {
    GdkGeometry _geo; _geo.min_width = _geo.min_height = 1;
    gtk_window_set_geometry_hints(GTK_WINDOW(this->mw),
        this->mw, &_geo, GDK_HINT_MIN_SIZE);
  }
  _0 = gtk_vbox_new(FALSE, 0);
  _267 = gtk_scrolled_window_new(0, 0);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(_267),
      GTK_SHADOW_NONE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(_267),
      GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
  gtk_scrolled_window_set_placement(GTK_SCROLLED_WINDOW(_267),
      GTK_CORNER_TOP_LEFT);
  this->a0 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a0), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a0, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t0 = gtk_entry_new();
  gtk_widget_set_size_request(this->t0, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t0, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen0 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen0), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen0, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p0 = gtk_button_new();
  _2 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_2), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_2, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l0 = gtk_button_new();
  _4 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_4), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_4, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n0 = gtk_entry_new();
  gtk_widget_set_size_request(this->n0, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n0, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len0 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len0), "0");
  gtk_widget_set_size_request(this->len0, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len0), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len0, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a1 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a1), " 1");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a1, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t1 = gtk_entry_new();
  gtk_widget_set_size_request(this->t1, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t1, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen1 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen1), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen1, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p1 = gtk_button_new();
  _6 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_6), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_6, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l1 = gtk_button_new();
  _8 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_8), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_8, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n1 = gtk_entry_new();
  gtk_widget_set_size_request(this->n1, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n1, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len1 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len1), "0");
  gtk_widget_set_size_request(this->len1, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len1), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len1, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a2 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a2), " 2");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a2, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t2 = gtk_entry_new();
  gtk_widget_set_size_request(this->t2, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t2, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen2 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen2), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen2, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p2 = gtk_button_new();
  _10 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_10), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_10, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l2 = gtk_button_new();
  _12 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_12), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_12, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n2 = gtk_entry_new();
  gtk_widget_set_size_request(this->n2, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n2, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len2 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len2), "0");
  gtk_widget_set_size_request(this->len2, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len2), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len2, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a3 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a3), " 3");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a3, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t3 = gtk_entry_new();
  gtk_widget_set_size_request(this->t3, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t3, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen3 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen3), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen3, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p3 = gtk_button_new();
  _14 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_14), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_14, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l3 = gtk_button_new();
  _16 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_16), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_16, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n3 = gtk_entry_new();
  gtk_widget_set_size_request(this->n3, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n3, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len3 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len3), "0");
  gtk_widget_set_size_request(this->len3, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len3), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len3, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a4 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a4), " 4");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a4, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t4 = gtk_entry_new();
  gtk_widget_set_size_request(this->t4, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t4, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen4 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen4), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen4, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p4 = gtk_button_new();
  _18 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_18), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_18, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l4 = gtk_button_new();
  _20 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_20), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_20, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n4 = gtk_entry_new();
  gtk_widget_set_size_request(this->n4, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n4, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len4 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len4), "0");
  gtk_widget_set_size_request(this->len4, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len4), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len4, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a5 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a5), " 5");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a5, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t5 = gtk_entry_new();
  gtk_widget_set_size_request(this->t5, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t5, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen5 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen5), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen5, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p5 = gtk_button_new();
  _22 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_22), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_22, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l5 = gtk_button_new();
  _24 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_24), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_24, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n5 = gtk_entry_new();
  gtk_widget_set_size_request(this->n5, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n5, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len5 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len5), "0");
  gtk_widget_set_size_request(this->len5, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len5), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len5, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a6 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a6), " 6");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a6, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t6 = gtk_entry_new();
  gtk_widget_set_size_request(this->t6, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t6, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen6 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen6), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen6, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p6 = gtk_button_new();
  _26 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_26), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_26, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l6 = gtk_button_new();
  _28 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_28), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_28, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n6 = gtk_entry_new();
  gtk_widget_set_size_request(this->n6, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n6, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len6 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len6), "0");
  gtk_widget_set_size_request(this->len6, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len6), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len6, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a7 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a7), " 7");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a7, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t7 = gtk_entry_new();
  gtk_widget_set_size_request(this->t7, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t7, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen7 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen7), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen7, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p7 = gtk_button_new();
  _30 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_30), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_30, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l7 = gtk_button_new();
  _32 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_32), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_32, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n7 = gtk_entry_new();
  gtk_widget_set_size_request(this->n7, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n7, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len7 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len7), "0");
  gtk_widget_set_size_request(this->len7, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len7), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len7, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a8 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a8), " 8");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a8, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t8 = gtk_entry_new();
  gtk_widget_set_size_request(this->t8, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t8, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen8 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen8), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen8, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p8 = gtk_button_new();
  _34 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_34), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_34, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l8 = gtk_button_new();
  _36 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_36), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_36, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n8 = gtk_entry_new();
  gtk_widget_set_size_request(this->n8, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n8, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len8 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len8), "0");
  gtk_widget_set_size_request(this->len8, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len8), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len8, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a9 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a9), " 9");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a9, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t9 = gtk_entry_new();
  gtk_widget_set_size_request(this->t9, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t9, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen9 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen9), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen9, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p9 = gtk_button_new();
  _38 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_38), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_38, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l9 = gtk_button_new();
  _40 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_40), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_40, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n9 = gtk_entry_new();
  gtk_widget_set_size_request(this->n9, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n9, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len9 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len9), "0");
  gtk_widget_set_size_request(this->len9, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len9), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len9, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a10 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a10), "10");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a10, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t10 = gtk_entry_new();
  gtk_widget_set_size_request(this->t10, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t10, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen10 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen10), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen10, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p10 = gtk_button_new();
  _42 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_42), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_42, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l10 = gtk_button_new();
  _44 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_44), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_44, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n10 = gtk_entry_new();
  gtk_widget_set_size_request(this->n10, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n10, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len10 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len10), "0");
  gtk_widget_set_size_request(this->len10, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len10), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len10, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a11 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a11), "11");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a11, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t11 = gtk_entry_new();
  gtk_widget_set_size_request(this->t11, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t11, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen11 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen11), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen11, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p11 = gtk_button_new();
  _46 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_46), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_46, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l11 = gtk_button_new();
  _48 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_48), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_48, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n11 = gtk_entry_new();
  gtk_widget_set_size_request(this->n11, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n11, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len11 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len11), "0");
  gtk_widget_set_size_request(this->len11, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len11), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len11, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a12 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a12), "12");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a12, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t12 = gtk_entry_new();
  gtk_widget_set_size_request(this->t12, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t12, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen12 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen12), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen12, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p12 = gtk_button_new();
  _50 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_50), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_50, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l12 = gtk_button_new();
  _52 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_52), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_52, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n12 = gtk_entry_new();
  gtk_widget_set_size_request(this->n12, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n12, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len12 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len12), "0");
  gtk_widget_set_size_request(this->len12, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len12), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len12, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a13 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a13), "13");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a13, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t13 = gtk_entry_new();
  gtk_widget_set_size_request(this->t13, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t13, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen13 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen13), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen13, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p13 = gtk_button_new();
  _54 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_54), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_54, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l13 = gtk_button_new();
  _56 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_56), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_56, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n13 = gtk_entry_new();
  gtk_widget_set_size_request(this->n13, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n13, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len13 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len13), "0");
  gtk_widget_set_size_request(this->len13, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len13), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len13, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a14 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a14), "14");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a14, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t14 = gtk_entry_new();
  gtk_widget_set_size_request(this->t14, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t14, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen14 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen14), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen14, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p14 = gtk_button_new();
  _58 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_58), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_58, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l14 = gtk_button_new();
  _60 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_60), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_60, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n14 = gtk_entry_new();
  gtk_widget_set_size_request(this->n14, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n14, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len14 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len14), "0");
  gtk_widget_set_size_request(this->len14, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len14), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len14, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a15 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a15), "15");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a15, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t15 = gtk_entry_new();
  gtk_widget_set_size_request(this->t15, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t15, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen15 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen15), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen15, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p15 = gtk_button_new();
  _62 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_62), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_62, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l15 = gtk_button_new();
  _64 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_64), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_64, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n15 = gtk_entry_new();
  gtk_widget_set_size_request(this->n15, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n15, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len15 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len15), "0");
  gtk_widget_set_size_request(this->len15, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len15), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len15, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a16 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a16), "16");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a16, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t16 = gtk_entry_new();
  gtk_widget_set_size_request(this->t16, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t16, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen16 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen16), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen16, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p16 = gtk_button_new();
  _66 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_66), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_66, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l16 = gtk_button_new();
  _68 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_68), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_68, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n16 = gtk_entry_new();
  gtk_widget_set_size_request(this->n16, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n16, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len16 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len16), "0");
  gtk_widget_set_size_request(this->len16, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len16), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len16, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a17 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a17), "17");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a17, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t17 = gtk_entry_new();
  gtk_widget_set_size_request(this->t17, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t17, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen17 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen17), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen17, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p17 = gtk_button_new();
  _70 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_70), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_70, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l17 = gtk_button_new();
  _72 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_72), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_72, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n17 = gtk_entry_new();
  gtk_widget_set_size_request(this->n17, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n17, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len17 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len17), "0");
  gtk_widget_set_size_request(this->len17, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len17), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len17, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a18 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a18), "18");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a18, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t18 = gtk_entry_new();
  gtk_widget_set_size_request(this->t18, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t18, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen18 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen18), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen18, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p18 = gtk_button_new();
  _74 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_74), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_74, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l18 = gtk_button_new();
  _76 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_76), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_76, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n18 = gtk_entry_new();
  gtk_widget_set_size_request(this->n18, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n18, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len18 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len18), "0");
  gtk_widget_set_size_request(this->len18, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len18), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len18, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a19 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a19), "19");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a19, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t19 = gtk_entry_new();
  gtk_widget_set_size_request(this->t19, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t19, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen19 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen19), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen19, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p19 = gtk_button_new();
  _78 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_78), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_78, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l19 = gtk_button_new();
  _80 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_80), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_80, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n19 = gtk_entry_new();
  gtk_widget_set_size_request(this->n19, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n19, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len19 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len19), "0");
  gtk_widget_set_size_request(this->len19, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len19), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len19, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a20 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a20), "20");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a20, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t20 = gtk_entry_new();
  gtk_widget_set_size_request(this->t20, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t20, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen20 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen20), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen20, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p20 = gtk_button_new();
  _82 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_82), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_82, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l20 = gtk_button_new();
  _84 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_84), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_84, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n20 = gtk_entry_new();
  gtk_widget_set_size_request(this->n20, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n20, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len20 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len20), "0");
  gtk_widget_set_size_request(this->len20, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len20), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len20, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a21 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a21), "21");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a21, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t21 = gtk_entry_new();
  gtk_widget_set_size_request(this->t21, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t21, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen21 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen21), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen21, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p21 = gtk_button_new();
  _86 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_86), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_86, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l21 = gtk_button_new();
  _88 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_88), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_88, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n21 = gtk_entry_new();
  gtk_widget_set_size_request(this->n21, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n21, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len21 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len21), "0");
  gtk_widget_set_size_request(this->len21, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len21), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len21, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a22 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a22), "22");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a22, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t22 = gtk_entry_new();
  gtk_widget_set_size_request(this->t22, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t22, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen22 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen22), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen22, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p22 = gtk_button_new();
  _90 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_90), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_90, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l22 = gtk_button_new();
  _92 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_92), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_92, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n22 = gtk_entry_new();
  gtk_widget_set_size_request(this->n22, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n22, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len22 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len22), "0");
  gtk_widget_set_size_request(this->len22, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len22), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len22, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a23 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a23), "23");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a23, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t23 = gtk_entry_new();
  gtk_widget_set_size_request(this->t23, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t23, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen23 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen23), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen23, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p23 = gtk_button_new();
  _94 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_94), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_94, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l23 = gtk_button_new();
  _96 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_96), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_96, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n23 = gtk_entry_new();
  gtk_widget_set_size_request(this->n23, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n23, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len23 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len23), "0");
  gtk_widget_set_size_request(this->len23, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len23), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len23, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a24 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a24), "24");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a24, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t24 = gtk_entry_new();
  gtk_widget_set_size_request(this->t24, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t24, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen24 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen24), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen24, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p24 = gtk_button_new();
  _98 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_98), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_98, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l24 = gtk_button_new();
  _100 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_100), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_100, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n24 = gtk_entry_new();
  gtk_widget_set_size_request(this->n24, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n24, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len24 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len24), "0");
  gtk_widget_set_size_request(this->len24, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len24), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len24, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a25 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a25), "25");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a25, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t25 = gtk_entry_new();
  gtk_widget_set_size_request(this->t25, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t25, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen25 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen25), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen25, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p25 = gtk_button_new();
  _102 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_102), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_102, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l25 = gtk_button_new();
  _104 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_104), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_104, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n25 = gtk_entry_new();
  gtk_widget_set_size_request(this->n25, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n25, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len25 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len25), "0");
  gtk_widget_set_size_request(this->len25, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len25), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len25, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a26 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a26), "26");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a26, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t26 = gtk_entry_new();
  gtk_widget_set_size_request(this->t26, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t26, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen26 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen26), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen26, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p26 = gtk_button_new();
  _106 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_106), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_106, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l26 = gtk_button_new();
  _108 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_108), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_108, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n26 = gtk_entry_new();
  gtk_widget_set_size_request(this->n26, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n26, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len26 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len26), "0");
  gtk_widget_set_size_request(this->len26, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len26), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len26, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a27 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a27), "27");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a27, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t27 = gtk_entry_new();
  gtk_widget_set_size_request(this->t27, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t27, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen27 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen27), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen27, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p27 = gtk_button_new();
  _110 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_110), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_110, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l27 = gtk_button_new();
  _112 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_112), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_112, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n27 = gtk_entry_new();
  gtk_widget_set_size_request(this->n27, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n27, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len27 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len27), "0");
  gtk_widget_set_size_request(this->len27, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len27), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len27, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a28 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a28), "28");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a28, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t28 = gtk_entry_new();
  gtk_widget_set_size_request(this->t28, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t28, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen28 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen28), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen28, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p28 = gtk_button_new();
  _114 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_114), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_114, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l28 = gtk_button_new();
  _116 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_116), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_116, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n28 = gtk_entry_new();
  gtk_widget_set_size_request(this->n28, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n28, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len28 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len28), "0");
  gtk_widget_set_size_request(this->len28, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len28), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len28, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a29 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a29), "29");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a29, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t29 = gtk_entry_new();
  gtk_widget_set_size_request(this->t29, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t29, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen29 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen29), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen29, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p29 = gtk_button_new();
  _118 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_118), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_118, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l29 = gtk_button_new();
  _120 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_120), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_120, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n29 = gtk_entry_new();
  gtk_widget_set_size_request(this->n29, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n29, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len29 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len29), "0");
  gtk_widget_set_size_request(this->len29, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len29), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len29, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a30 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a30), "30");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a30, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t30 = gtk_entry_new();
  gtk_widget_set_size_request(this->t30, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t30, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen30 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen30), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen30, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p30 = gtk_button_new();
  _122 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_122), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_122, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l30 = gtk_button_new();
  _124 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_124), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_124, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n30 = gtk_entry_new();
  gtk_widget_set_size_request(this->n30, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n30, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len30 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len30), "0");
  gtk_widget_set_size_request(this->len30, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len30), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len30, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a31 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a31), "31");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a31, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t31 = gtk_entry_new();
  gtk_widget_set_size_request(this->t31, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t31, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen31 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen31), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen31, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p31 = gtk_button_new();
  _126 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_126), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_126, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l31 = gtk_button_new();
  _128 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_128), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_128, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n31 = gtk_entry_new();
  gtk_widget_set_size_request(this->n31, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n31, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len31 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len31), "0");
  gtk_widget_set_size_request(this->len31, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len31), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len31, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a32 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a32), "32");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a32, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t32 = gtk_entry_new();
  gtk_widget_set_size_request(this->t32, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t32, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen32 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen32), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen32, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p32 = gtk_button_new();
  _130 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_130), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_130, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l32 = gtk_button_new();
  _132 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_132), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_132, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n32 = gtk_entry_new();
  gtk_widget_set_size_request(this->n32, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n32, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len32 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len32), "0");
  gtk_widget_set_size_request(this->len32, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len32), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len32, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a33 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a33), "33");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a33, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t33 = gtk_entry_new();
  gtk_widget_set_size_request(this->t33, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t33, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen33 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen33), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen33, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p33 = gtk_button_new();
  _134 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_134), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_134, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l33 = gtk_button_new();
  _136 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_136), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_136, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n33 = gtk_entry_new();
  gtk_widget_set_size_request(this->n33, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n33, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len33 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len33), "0");
  gtk_widget_set_size_request(this->len33, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len33), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len33, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a34 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a34), "34");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a34, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t34 = gtk_entry_new();
  gtk_widget_set_size_request(this->t34, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t34, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen34 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen34), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen34, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p34 = gtk_button_new();
  _138 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_138), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_138, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l34 = gtk_button_new();
  _140 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_140), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_140, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n34 = gtk_entry_new();
  gtk_widget_set_size_request(this->n34, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n34, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len34 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len34), "0");
  gtk_widget_set_size_request(this->len34, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len34), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len34, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a35 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a35), "35");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a35, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t35 = gtk_entry_new();
  gtk_widget_set_size_request(this->t35, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t35, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen35 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen35), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen35, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p35 = gtk_button_new();
  _142 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_142), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_142, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l35 = gtk_button_new();
  _144 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_144), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_144, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n35 = gtk_entry_new();
  gtk_widget_set_size_request(this->n35, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n35, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len35 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len35), "0");
  gtk_widget_set_size_request(this->len35, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len35), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len35, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a36 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a36), "36");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a36, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t36 = gtk_entry_new();
  gtk_widget_set_size_request(this->t36, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t36, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen36 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen36), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen36, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p36 = gtk_button_new();
  _146 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_146), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_146, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l36 = gtk_button_new();
  _148 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_148), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_148, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n36 = gtk_entry_new();
  gtk_widget_set_size_request(this->n36, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n36, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len36 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len36), "0");
  gtk_widget_set_size_request(this->len36, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len36), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len36, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a37 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a37), "37");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a37, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t37 = gtk_entry_new();
  gtk_widget_set_size_request(this->t37, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t37, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen37 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen37), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen37, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p37 = gtk_button_new();
  _150 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_150), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_150, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l37 = gtk_button_new();
  _152 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_152), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_152, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n37 = gtk_entry_new();
  gtk_widget_set_size_request(this->n37, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n37, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len37 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len37), "0");
  gtk_widget_set_size_request(this->len37, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len37), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len37, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a38 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a38), "38");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a38, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t38 = gtk_entry_new();
  gtk_widget_set_size_request(this->t38, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t38, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen38 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen38), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen38, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p38 = gtk_button_new();
  _154 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_154), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_154, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l38 = gtk_button_new();
  _156 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_156), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_156, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n38 = gtk_entry_new();
  gtk_widget_set_size_request(this->n38, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n38, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len38 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len38), "0");
  gtk_widget_set_size_request(this->len38, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len38), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len38, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a39 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a39), "39");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a39, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t39 = gtk_entry_new();
  gtk_widget_set_size_request(this->t39, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t39, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen39 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen39), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen39, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p39 = gtk_button_new();
  _158 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_158), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_158, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l39 = gtk_button_new();
  _160 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_160), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_160, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n39 = gtk_entry_new();
  gtk_widget_set_size_request(this->n39, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n39, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len39 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len39), "0");
  gtk_widget_set_size_request(this->len39, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len39), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len39, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a40 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a40), "40");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a40, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t40 = gtk_entry_new();
  gtk_widget_set_size_request(this->t40, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t40, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen40 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen40), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen40, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p40 = gtk_button_new();
  _162 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_162), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_162, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l40 = gtk_button_new();
  _164 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_164), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_164, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n40 = gtk_entry_new();
  gtk_widget_set_size_request(this->n40, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n40, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len40 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len40), "0");
  gtk_widget_set_size_request(this->len40, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len40), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len40, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a41 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a41), "41");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a41, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t41 = gtk_entry_new();
  gtk_widget_set_size_request(this->t41, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t41, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen41 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen41), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen41, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p41 = gtk_button_new();
  _166 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_166), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_166, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l41 = gtk_button_new();
  _168 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_168), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_168, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n41 = gtk_entry_new();
  gtk_widget_set_size_request(this->n41, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n41, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len41 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len41), "0");
  gtk_widget_set_size_request(this->len41, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len41), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len41, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a42 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a42), "42");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a42, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t42 = gtk_entry_new();
  gtk_widget_set_size_request(this->t42, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t42, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen42 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen42), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen42, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p42 = gtk_button_new();
  _170 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_170), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_170, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l42 = gtk_button_new();
  _172 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_172), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_172, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n42 = gtk_entry_new();
  gtk_widget_set_size_request(this->n42, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n42, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len42 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len42), "0");
  gtk_widget_set_size_request(this->len42, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len42), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len42, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a43 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a43), "43");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a43, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t43 = gtk_entry_new();
  gtk_widget_set_size_request(this->t43, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t43, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen43 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen43), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen43, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p43 = gtk_button_new();
  _174 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_174), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_174, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l43 = gtk_button_new();
  _176 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_176), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_176, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n43 = gtk_entry_new();
  gtk_widget_set_size_request(this->n43, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n43, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len43 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len43), "0");
  gtk_widget_set_size_request(this->len43, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len43), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len43, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a44 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a44), "44");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a44, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t44 = gtk_entry_new();
  gtk_widget_set_size_request(this->t44, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t44, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen44 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen44), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen44, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p44 = gtk_button_new();
  _178 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_178), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_178, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l44 = gtk_button_new();
  _180 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_180), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_180, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n44 = gtk_entry_new();
  gtk_widget_set_size_request(this->n44, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n44, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len44 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len44), "0");
  gtk_widget_set_size_request(this->len44, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len44), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len44, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a45 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a45), "45");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a45, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t45 = gtk_entry_new();
  gtk_widget_set_size_request(this->t45, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t45, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen45 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen45), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen45, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p45 = gtk_button_new();
  _182 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_182), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_182, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l45 = gtk_button_new();
  _184 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_184), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_184, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n45 = gtk_entry_new();
  gtk_widget_set_size_request(this->n45, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n45, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len45 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len45), "0");
  gtk_widget_set_size_request(this->len45, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len45), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len45, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a46 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a46), "46");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a46, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t46 = gtk_entry_new();
  gtk_widget_set_size_request(this->t46, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t46, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen46 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen46), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen46, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p46 = gtk_button_new();
  _186 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_186), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_186, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l46 = gtk_button_new();
  _188 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_188), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_188, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n46 = gtk_entry_new();
  gtk_widget_set_size_request(this->n46, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n46, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len46 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len46), "0");
  gtk_widget_set_size_request(this->len46, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len46), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len46, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a47 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a47), "47");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a47, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t47 = gtk_entry_new();
  gtk_widget_set_size_request(this->t47, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t47, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen47 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen47), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen47, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p47 = gtk_button_new();
  _190 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_190), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_190, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l47 = gtk_button_new();
  _192 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_192), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_192, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n47 = gtk_entry_new();
  gtk_widget_set_size_request(this->n47, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n47, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len47 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len47), "0");
  gtk_widget_set_size_request(this->len47, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len47), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len47, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a48 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->a48), "48");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->a48, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->t48 = gtk_entry_new();
  gtk_widget_set_size_request(this->t48, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->t48, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->nlen48 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->nlen48), " 0");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->nlen48, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->p48 = gtk_button_new();
  _194 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_194), "play");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_194, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->l48 = gtk_button_new();
  _196 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_196), "load");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_196, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->n48 = gtk_entry_new();
  gtk_widget_set_size_request(this->n48, 200, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->n48, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->len48 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->len48), "0");
  gtk_widget_set_size_request(this->len48, 180, -1);
  gtk_misc_set_alignment(GTK_MISC(this->len48), 1.000000, 0.500000);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->len48, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->audio1 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->audio1), "audio u16");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->audio1, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->ta1 = gtk_entry_new();
  gtk_widget_set_size_request(this->ta1, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->ta1, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a1f = gtk_button_new();
  _198 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_198), "choose");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_198, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->audio2 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->audio2), "audio u15");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->audio2, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->ta2 = gtk_entry_new();
  gtk_widget_set_size_request(this->ta2, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->ta2, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->a2f = gtk_button_new();
  _200 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_200), "choose");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_200, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->code = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->code), "     code");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->code, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->tc = gtk_entry_new();
  gtk_widget_set_size_request(this->tc, 250, -1);
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->tc, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->cf = gtk_button_new();
  _202 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_202), "choose");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_202, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->ab = gtk_vbox_new(FALSE, 0);
  this->compute = gtk_button_new();
  _204 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_204), "_Compute");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_204, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->save = gtk_button_new();
  _206 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_206), "_Save");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_206, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->quit = gtk_button_new();
  _208 = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(_208), "_Quit");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(_208, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->x = gtk_vbox_new(FALSE, 0);
  this->bb = gtk_vbox_new(FALSE, 0);
  this->zz = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->zz), "--------------------");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->zz, _font_desc);
    pango_font_description_free(_font_desc);
  }
  this->info = gtk_label_new(0);
  gtk_label_set_markup_with_mnemonic(GTK_LABEL(this->info), "OK");
  {
    PangoFontDescription *_font_desc =
        pango_font_description_from_string("monospace 9");
    gtk_widget_modify_font(this->info, _font_desc);
    pango_font_description_free(_font_desc);
  }
  _210 = gtk_hbox_new(FALSE, 0);
  _211 = gtk_hbox_new(FALSE, 0);
  _212 = gtk_hbox_new(FALSE, 0);
  _213 = gtk_hbox_new(FALSE, 0);
  _214 = gtk_hbox_new(FALSE, 0);
  _215 = gtk_hbox_new(FALSE, 0);
  _216 = gtk_hbox_new(FALSE, 0);
  _217 = gtk_hbox_new(FALSE, 0);
  _218 = gtk_hbox_new(FALSE, 0);
  _219 = gtk_hbox_new(FALSE, 0);
  _220 = gtk_hbox_new(FALSE, 0);
  _221 = gtk_hbox_new(FALSE, 0);
  _222 = gtk_hbox_new(FALSE, 0);
  _223 = gtk_hbox_new(FALSE, 0);
  _224 = gtk_hbox_new(FALSE, 0);
  _225 = gtk_hbox_new(FALSE, 0);
  _226 = gtk_hbox_new(FALSE, 0);
  _227 = gtk_hbox_new(FALSE, 0);
  _228 = gtk_hbox_new(FALSE, 0);
  _229 = gtk_hbox_new(FALSE, 0);
  _230 = gtk_hbox_new(FALSE, 0);
  _231 = gtk_hbox_new(FALSE, 0);
  _232 = gtk_hbox_new(FALSE, 0);
  _233 = gtk_hbox_new(FALSE, 0);
  _234 = gtk_hbox_new(FALSE, 0);
  _235 = gtk_hbox_new(FALSE, 0);
  _236 = gtk_hbox_new(FALSE, 0);
  _237 = gtk_hbox_new(FALSE, 0);
  _238 = gtk_hbox_new(FALSE, 0);
  _239 = gtk_hbox_new(FALSE, 0);
  _240 = gtk_hbox_new(FALSE, 0);
  _241 = gtk_hbox_new(FALSE, 0);
  _242 = gtk_hbox_new(FALSE, 0);
  _243 = gtk_hbox_new(FALSE, 0);
  _244 = gtk_hbox_new(FALSE, 0);
  _245 = gtk_hbox_new(FALSE, 0);
  _246 = gtk_hbox_new(FALSE, 0);
  _247 = gtk_hbox_new(FALSE, 0);
  _248 = gtk_hbox_new(FALSE, 0);
  _249 = gtk_hbox_new(FALSE, 0);
  _250 = gtk_hbox_new(FALSE, 0);
  _251 = gtk_hbox_new(FALSE, 0);
  _252 = gtk_hbox_new(FALSE, 0);
  _253 = gtk_hbox_new(FALSE, 0);
  _254 = gtk_hbox_new(FALSE, 0);
  _255 = gtk_hbox_new(FALSE, 0);
  _256 = gtk_hbox_new(FALSE, 0);
  _257 = gtk_hbox_new(FALSE, 0);
  _258 = gtk_hbox_new(FALSE, 0);
  _259 = gtk_hbox_new(FALSE, 0);
  _260 = gtk_hbox_new(FALSE, 0);
  _261 = gtk_hbox_new(FALSE, 0);
  _262 = gtk_hbox_new(FALSE, 0);
  _263 = gtk_hbox_new(FALSE, 0);
  _264 = gtk_hbox_new(FALSE, 0);
  _265 = gtk_hbox_new(FALSE, 0);
  _266 = gtk_hbox_new(FALSE, 0);
  _268 = gtk_viewport_new(0, 0);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(_268),
      GTK_SHADOW_NONE);
  this->w = gtk_vbox_new(FALSE, 0);

  gtk_container_add(GTK_CONTAINER(this->mw), _0);
  gtk_box_pack_start(GTK_BOX(_0), _210, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_0), _211, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), _212, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_0), _213, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(_267), _268);
  gtk_container_add(GTK_CONTAINER(this->p0), _2);
  gtk_container_add(GTK_CONTAINER(this->l0), _4);
  gtk_container_add(GTK_CONTAINER(this->p1), _6);
  gtk_container_add(GTK_CONTAINER(this->l1), _8);
  gtk_container_add(GTK_CONTAINER(this->p2), _10);
  gtk_container_add(GTK_CONTAINER(this->l2), _12);
  gtk_container_add(GTK_CONTAINER(this->p3), _14);
  gtk_container_add(GTK_CONTAINER(this->l3), _16);
  gtk_container_add(GTK_CONTAINER(this->p4), _18);
  gtk_container_add(GTK_CONTAINER(this->l4), _20);
  gtk_container_add(GTK_CONTAINER(this->p5), _22);
  gtk_container_add(GTK_CONTAINER(this->l5), _24);
  gtk_container_add(GTK_CONTAINER(this->p6), _26);
  gtk_container_add(GTK_CONTAINER(this->l6), _28);
  gtk_container_add(GTK_CONTAINER(this->p7), _30);
  gtk_container_add(GTK_CONTAINER(this->l7), _32);
  gtk_container_add(GTK_CONTAINER(this->p8), _34);
  gtk_container_add(GTK_CONTAINER(this->l8), _36);
  gtk_container_add(GTK_CONTAINER(this->p9), _38);
  gtk_container_add(GTK_CONTAINER(this->l9), _40);
  gtk_container_add(GTK_CONTAINER(this->p10), _42);
  gtk_container_add(GTK_CONTAINER(this->l10), _44);
  gtk_container_add(GTK_CONTAINER(this->p11), _46);
  gtk_container_add(GTK_CONTAINER(this->l11), _48);
  gtk_container_add(GTK_CONTAINER(this->p12), _50);
  gtk_container_add(GTK_CONTAINER(this->l12), _52);
  gtk_container_add(GTK_CONTAINER(this->p13), _54);
  gtk_container_add(GTK_CONTAINER(this->l13), _56);
  gtk_container_add(GTK_CONTAINER(this->p14), _58);
  gtk_container_add(GTK_CONTAINER(this->l14), _60);
  gtk_container_add(GTK_CONTAINER(this->p15), _62);
  gtk_container_add(GTK_CONTAINER(this->l15), _64);
  gtk_container_add(GTK_CONTAINER(this->p16), _66);
  gtk_container_add(GTK_CONTAINER(this->l16), _68);
  gtk_container_add(GTK_CONTAINER(this->p17), _70);
  gtk_container_add(GTK_CONTAINER(this->l17), _72);
  gtk_container_add(GTK_CONTAINER(this->p18), _74);
  gtk_container_add(GTK_CONTAINER(this->l18), _76);
  gtk_container_add(GTK_CONTAINER(this->p19), _78);
  gtk_container_add(GTK_CONTAINER(this->l19), _80);
  gtk_container_add(GTK_CONTAINER(this->p20), _82);
  gtk_container_add(GTK_CONTAINER(this->l20), _84);
  gtk_container_add(GTK_CONTAINER(this->p21), _86);
  gtk_container_add(GTK_CONTAINER(this->l21), _88);
  gtk_container_add(GTK_CONTAINER(this->p22), _90);
  gtk_container_add(GTK_CONTAINER(this->l22), _92);
  gtk_container_add(GTK_CONTAINER(this->p23), _94);
  gtk_container_add(GTK_CONTAINER(this->l23), _96);
  gtk_container_add(GTK_CONTAINER(this->p24), _98);
  gtk_container_add(GTK_CONTAINER(this->l24), _100);
  gtk_container_add(GTK_CONTAINER(this->p25), _102);
  gtk_container_add(GTK_CONTAINER(this->l25), _104);
  gtk_container_add(GTK_CONTAINER(this->p26), _106);
  gtk_container_add(GTK_CONTAINER(this->l26), _108);
  gtk_container_add(GTK_CONTAINER(this->p27), _110);
  gtk_container_add(GTK_CONTAINER(this->l27), _112);
  gtk_container_add(GTK_CONTAINER(this->p28), _114);
  gtk_container_add(GTK_CONTAINER(this->l28), _116);
  gtk_container_add(GTK_CONTAINER(this->p29), _118);
  gtk_container_add(GTK_CONTAINER(this->l29), _120);
  gtk_container_add(GTK_CONTAINER(this->p30), _122);
  gtk_container_add(GTK_CONTAINER(this->l30), _124);
  gtk_container_add(GTK_CONTAINER(this->p31), _126);
  gtk_container_add(GTK_CONTAINER(this->l31), _128);
  gtk_container_add(GTK_CONTAINER(this->p32), _130);
  gtk_container_add(GTK_CONTAINER(this->l32), _132);
  gtk_container_add(GTK_CONTAINER(this->p33), _134);
  gtk_container_add(GTK_CONTAINER(this->l33), _136);
  gtk_container_add(GTK_CONTAINER(this->p34), _138);
  gtk_container_add(GTK_CONTAINER(this->l34), _140);
  gtk_container_add(GTK_CONTAINER(this->p35), _142);
  gtk_container_add(GTK_CONTAINER(this->l35), _144);
  gtk_container_add(GTK_CONTAINER(this->p36), _146);
  gtk_container_add(GTK_CONTAINER(this->l36), _148);
  gtk_container_add(GTK_CONTAINER(this->p37), _150);
  gtk_container_add(GTK_CONTAINER(this->l37), _152);
  gtk_container_add(GTK_CONTAINER(this->p38), _154);
  gtk_container_add(GTK_CONTAINER(this->l38), _156);
  gtk_container_add(GTK_CONTAINER(this->p39), _158);
  gtk_container_add(GTK_CONTAINER(this->l39), _160);
  gtk_container_add(GTK_CONTAINER(this->p40), _162);
  gtk_container_add(GTK_CONTAINER(this->l40), _164);
  gtk_container_add(GTK_CONTAINER(this->p41), _166);
  gtk_container_add(GTK_CONTAINER(this->l41), _168);
  gtk_container_add(GTK_CONTAINER(this->p42), _170);
  gtk_container_add(GTK_CONTAINER(this->l42), _172);
  gtk_container_add(GTK_CONTAINER(this->p43), _174);
  gtk_container_add(GTK_CONTAINER(this->l43), _176);
  gtk_container_add(GTK_CONTAINER(this->p44), _178);
  gtk_container_add(GTK_CONTAINER(this->l44), _180);
  gtk_container_add(GTK_CONTAINER(this->p45), _182);
  gtk_container_add(GTK_CONTAINER(this->l45), _184);
  gtk_container_add(GTK_CONTAINER(this->p46), _186);
  gtk_container_add(GTK_CONTAINER(this->l46), _188);
  gtk_container_add(GTK_CONTAINER(this->p47), _190);
  gtk_container_add(GTK_CONTAINER(this->l47), _192);
  gtk_container_add(GTK_CONTAINER(this->p48), _194);
  gtk_container_add(GTK_CONTAINER(this->l48), _196);
  gtk_container_add(GTK_CONTAINER(this->a1f), _198);
  gtk_container_add(GTK_CONTAINER(this->a2f), _200);
  gtk_container_add(GTK_CONTAINER(this->cf), _202);
  gtk_box_pack_start(GTK_BOX(this->ab), _263, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->ab), _264, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->ab), _265, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(this->compute), _204);
  gtk_container_add(GTK_CONTAINER(this->save), _206);
  gtk_container_add(GTK_CONTAINER(this->quit), _208);
  gtk_box_pack_start(GTK_BOX(this->bb), _266, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_210), _267, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_211), this->zz, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_212), this->ab, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_212), this->bb, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_213), this->info, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_214), this->a0, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_214), this->n0, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_214), this->nlen0, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_214), this->t0, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_214), this->l0, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_214), this->p0, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_214), this->len0, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_215), this->a1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_215), this->n1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_215), this->nlen1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_215), this->t1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_215), this->l1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_215), this->p1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_215), this->len1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_216), this->a2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_216), this->n2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_216), this->nlen2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_216), this->t2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_216), this->l2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_216), this->p2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_216), this->len2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_217), this->a3, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_217), this->n3, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_217), this->nlen3, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_217), this->t3, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_217), this->l3, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_217), this->p3, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_217), this->len3, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_218), this->a4, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_218), this->n4, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_218), this->nlen4, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_218), this->t4, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_218), this->l4, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_218), this->p4, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_218), this->len4, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_219), this->a5, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_219), this->n5, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_219), this->nlen5, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_219), this->t5, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_219), this->l5, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_219), this->p5, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_219), this->len5, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_220), this->a6, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_220), this->n6, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_220), this->nlen6, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_220), this->t6, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_220), this->l6, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_220), this->p6, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_220), this->len6, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_221), this->a7, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_221), this->n7, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_221), this->nlen7, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_221), this->t7, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_221), this->l7, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_221), this->p7, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_221), this->len7, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_222), this->a8, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_222), this->n8, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_222), this->nlen8, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_222), this->t8, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_222), this->l8, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_222), this->p8, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_222), this->len8, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_223), this->a9, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_223), this->n9, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_223), this->nlen9, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_223), this->t9, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_223), this->l9, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_223), this->p9, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_223), this->len9, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_224), this->a10, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_224), this->n10, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_224), this->nlen10, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_224), this->t10, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_224), this->l10, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_224), this->p10, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_224), this->len10, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_225), this->a11, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_225), this->n11, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_225), this->nlen11, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_225), this->t11, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_225), this->l11, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_225), this->p11, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_225), this->len11, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_226), this->a12, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_226), this->n12, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_226), this->nlen12, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_226), this->t12, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_226), this->l12, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_226), this->p12, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_226), this->len12, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_227), this->a13, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_227), this->n13, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_227), this->nlen13, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_227), this->t13, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_227), this->l13, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_227), this->p13, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_227), this->len13, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_228), this->a14, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_228), this->n14, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_228), this->nlen14, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_228), this->t14, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_228), this->l14, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_228), this->p14, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_228), this->len14, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_229), this->a15, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_229), this->n15, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_229), this->nlen15, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_229), this->t15, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_229), this->l15, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_229), this->p15, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_229), this->len15, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_230), this->a16, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_230), this->n16, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_230), this->nlen16, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_230), this->t16, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_230), this->l16, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_230), this->p16, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_230), this->len16, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_231), this->a17, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_231), this->n17, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_231), this->nlen17, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_231), this->t17, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_231), this->l17, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_231), this->p17, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_231), this->len17, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_232), this->a18, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_232), this->n18, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_232), this->nlen18, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_232), this->t18, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_232), this->l18, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_232), this->p18, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_232), this->len18, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_233), this->a19, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_233), this->n19, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_233), this->nlen19, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_233), this->t19, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_233), this->l19, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_233), this->p19, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_233), this->len19, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_234), this->a20, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_234), this->n20, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_234), this->nlen20, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_234), this->t20, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_234), this->l20, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_234), this->p20, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_234), this->len20, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_235), this->a21, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_235), this->n21, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_235), this->nlen21, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_235), this->t21, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_235), this->l21, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_235), this->p21, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_235), this->len21, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_236), this->a22, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_236), this->n22, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_236), this->nlen22, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_236), this->t22, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_236), this->l22, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_236), this->p22, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_236), this->len22, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_237), this->a23, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_237), this->n23, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_237), this->nlen23, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_237), this->t23, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_237), this->l23, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_237), this->p23, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_237), this->len23, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_238), this->a24, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_238), this->n24, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_238), this->nlen24, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_238), this->t24, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_238), this->l24, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_238), this->p24, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_238), this->len24, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_239), this->a25, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_239), this->n25, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_239), this->nlen25, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_239), this->t25, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_239), this->l25, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_239), this->p25, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_239), this->len25, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_240), this->a26, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_240), this->n26, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_240), this->nlen26, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_240), this->t26, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_240), this->l26, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_240), this->p26, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_240), this->len26, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_241), this->a27, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_241), this->n27, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_241), this->nlen27, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_241), this->t27, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_241), this->l27, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_241), this->p27, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_241), this->len27, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_242), this->a28, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_242), this->n28, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_242), this->nlen28, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_242), this->t28, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_242), this->l28, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_242), this->p28, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_242), this->len28, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_243), this->a29, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_243), this->n29, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_243), this->nlen29, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_243), this->t29, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_243), this->l29, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_243), this->p29, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_243), this->len29, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_244), this->a30, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_244), this->n30, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_244), this->nlen30, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_244), this->t30, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_244), this->l30, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_244), this->p30, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_244), this->len30, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_245), this->a31, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_245), this->n31, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_245), this->nlen31, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_245), this->t31, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_245), this->l31, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_245), this->p31, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_245), this->len31, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_246), this->a32, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_246), this->n32, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_246), this->nlen32, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_246), this->t32, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_246), this->l32, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_246), this->p32, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_246), this->len32, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_247), this->a33, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_247), this->n33, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_247), this->nlen33, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_247), this->t33, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_247), this->l33, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_247), this->p33, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_247), this->len33, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_248), this->a34, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_248), this->n34, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_248), this->nlen34, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_248), this->t34, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_248), this->l34, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_248), this->p34, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_248), this->len34, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_249), this->a35, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_249), this->n35, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_249), this->nlen35, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_249), this->t35, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_249), this->l35, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_249), this->p35, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_249), this->len35, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_250), this->a36, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_250), this->n36, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_250), this->nlen36, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_250), this->t36, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_250), this->l36, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_250), this->p36, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_250), this->len36, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_251), this->a37, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_251), this->n37, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_251), this->nlen37, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_251), this->t37, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_251), this->l37, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_251), this->p37, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_251), this->len37, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_252), this->a38, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_252), this->n38, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_252), this->nlen38, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_252), this->t38, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_252), this->l38, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_252), this->p38, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_252), this->len38, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_253), this->a39, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_253), this->n39, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_253), this->nlen39, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_253), this->t39, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_253), this->l39, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_253), this->p39, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_253), this->len39, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_254), this->a40, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_254), this->n40, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_254), this->nlen40, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_254), this->t40, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_254), this->l40, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_254), this->p40, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_254), this->len40, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_255), this->a41, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_255), this->n41, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_255), this->nlen41, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_255), this->t41, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_255), this->l41, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_255), this->p41, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_255), this->len41, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_256), this->a42, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_256), this->n42, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_256), this->nlen42, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_256), this->t42, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_256), this->l42, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_256), this->p42, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_256), this->len42, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_257), this->a43, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_257), this->n43, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_257), this->nlen43, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_257), this->t43, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_257), this->l43, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_257), this->p43, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_257), this->len43, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_258), this->a44, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_258), this->n44, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_258), this->nlen44, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_258), this->t44, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_258), this->l44, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_258), this->p44, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_258), this->len44, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_259), this->a45, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_259), this->n45, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_259), this->nlen45, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_259), this->t45, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_259), this->l45, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_259), this->p45, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_259), this->len45, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_260), this->a46, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_260), this->n46, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_260), this->nlen46, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_260), this->t46, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_260), this->l46, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_260), this->p46, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_260), this->len46, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_261), this->a47, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_261), this->n47, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_261), this->nlen47, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_261), this->t47, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_261), this->l47, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_261), this->p47, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_261), this->len47, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_262), this->a48, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_262), this->n48, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_262), this->nlen48, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_262), this->t48, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_262), this->l48, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_262), this->p48, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_262), this->len48, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_263), this->audio1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_263), this->ta1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_263), this->a1f, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_264), this->audio2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_264), this->ta2, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_264), this->a2f, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_265), this->code, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_265), this->tc, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_265), this->cf, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_266), this->x, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(_266), this->compute, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_266), this->save, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(_266), this->quit, FALSE, FALSE, 0);
  gtk_container_add(GTK_CONTAINER(_268), this->w);
  gtk_box_pack_start(GTK_BOX(this->w), _214, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _215, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _216, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _217, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _218, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _219, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _220, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _221, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _222, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _223, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _224, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _225, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _226, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _227, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _228, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _229, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _230, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _231, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _232, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _233, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _234, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _235, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _236, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _237, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _238, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _239, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _240, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _241, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _242, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _243, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _244, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _245, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _246, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _247, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _248, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _249, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _250, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _251, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _252, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _253, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _254, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _255, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _256, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _257, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _258, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _259, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _260, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _261, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(this->w), _262, FALSE, FALSE, 0);


  this->mw_delete = g_signal_connect(this->mw, "delete-event", G_CALLBACK(_1), this);

  this->p0_clicked = g_signal_connect(this->p0, "clicked", G_CALLBACK(_3), this);

  this->l0_clicked = g_signal_connect(this->l0, "clicked", G_CALLBACK(_5), this);

  this->p1_clicked = g_signal_connect(this->p1, "clicked", G_CALLBACK(_7), this);

  this->l1_clicked = g_signal_connect(this->l1, "clicked", G_CALLBACK(_9), this);

  this->p2_clicked = g_signal_connect(this->p2, "clicked", G_CALLBACK(_11), this);

  this->l2_clicked = g_signal_connect(this->l2, "clicked", G_CALLBACK(_13), this);

  this->p3_clicked = g_signal_connect(this->p3, "clicked", G_CALLBACK(_15), this);

  this->l3_clicked = g_signal_connect(this->l3, "clicked", G_CALLBACK(_17), this);

  this->p4_clicked = g_signal_connect(this->p4, "clicked", G_CALLBACK(_19), this);

  this->l4_clicked = g_signal_connect(this->l4, "clicked", G_CALLBACK(_21), this);

  this->p5_clicked = g_signal_connect(this->p5, "clicked", G_CALLBACK(_23), this);

  this->l5_clicked = g_signal_connect(this->l5, "clicked", G_CALLBACK(_25), this);

  this->p6_clicked = g_signal_connect(this->p6, "clicked", G_CALLBACK(_27), this);

  this->l6_clicked = g_signal_connect(this->l6, "clicked", G_CALLBACK(_29), this);

  this->p7_clicked = g_signal_connect(this->p7, "clicked", G_CALLBACK(_31), this);

  this->l7_clicked = g_signal_connect(this->l7, "clicked", G_CALLBACK(_33), this);

  this->p8_clicked = g_signal_connect(this->p8, "clicked", G_CALLBACK(_35), this);

  this->l8_clicked = g_signal_connect(this->l8, "clicked", G_CALLBACK(_37), this);

  this->p9_clicked = g_signal_connect(this->p9, "clicked", G_CALLBACK(_39), this);

  this->l9_clicked = g_signal_connect(this->l9, "clicked", G_CALLBACK(_41), this);

  this->p10_clicked = g_signal_connect(this->p10, "clicked", G_CALLBACK(_43), this);

  this->l10_clicked = g_signal_connect(this->l10, "clicked", G_CALLBACK(_45), this);

  this->p11_clicked = g_signal_connect(this->p11, "clicked", G_CALLBACK(_47), this);

  this->l11_clicked = g_signal_connect(this->l11, "clicked", G_CALLBACK(_49), this);

  this->p12_clicked = g_signal_connect(this->p12, "clicked", G_CALLBACK(_51), this);

  this->l12_clicked = g_signal_connect(this->l12, "clicked", G_CALLBACK(_53), this);

  this->p13_clicked = g_signal_connect(this->p13, "clicked", G_CALLBACK(_55), this);

  this->l13_clicked = g_signal_connect(this->l13, "clicked", G_CALLBACK(_57), this);

  this->p14_clicked = g_signal_connect(this->p14, "clicked", G_CALLBACK(_59), this);

  this->l14_clicked = g_signal_connect(this->l14, "clicked", G_CALLBACK(_61), this);

  this->p15_clicked = g_signal_connect(this->p15, "clicked", G_CALLBACK(_63), this);

  this->l15_clicked = g_signal_connect(this->l15, "clicked", G_CALLBACK(_65), this);

  this->p16_clicked = g_signal_connect(this->p16, "clicked", G_CALLBACK(_67), this);

  this->l16_clicked = g_signal_connect(this->l16, "clicked", G_CALLBACK(_69), this);

  this->p17_clicked = g_signal_connect(this->p17, "clicked", G_CALLBACK(_71), this);

  this->l17_clicked = g_signal_connect(this->l17, "clicked", G_CALLBACK(_73), this);

  this->p18_clicked = g_signal_connect(this->p18, "clicked", G_CALLBACK(_75), this);

  this->l18_clicked = g_signal_connect(this->l18, "clicked", G_CALLBACK(_77), this);

  this->p19_clicked = g_signal_connect(this->p19, "clicked", G_CALLBACK(_79), this);

  this->l19_clicked = g_signal_connect(this->l19, "clicked", G_CALLBACK(_81), this);

  this->p20_clicked = g_signal_connect(this->p20, "clicked", G_CALLBACK(_83), this);

  this->l20_clicked = g_signal_connect(this->l20, "clicked", G_CALLBACK(_85), this);

  this->p21_clicked = g_signal_connect(this->p21, "clicked", G_CALLBACK(_87), this);

  this->l21_clicked = g_signal_connect(this->l21, "clicked", G_CALLBACK(_89), this);

  this->p22_clicked = g_signal_connect(this->p22, "clicked", G_CALLBACK(_91), this);

  this->l22_clicked = g_signal_connect(this->l22, "clicked", G_CALLBACK(_93), this);

  this->p23_clicked = g_signal_connect(this->p23, "clicked", G_CALLBACK(_95), this);

  this->l23_clicked = g_signal_connect(this->l23, "clicked", G_CALLBACK(_97), this);

  this->p24_clicked = g_signal_connect(this->p24, "clicked", G_CALLBACK(_99), this);

  this->l24_clicked = g_signal_connect(this->l24, "clicked", G_CALLBACK(_101), this);

  this->p25_clicked = g_signal_connect(this->p25, "clicked", G_CALLBACK(_103), this);

  this->l25_clicked = g_signal_connect(this->l25, "clicked", G_CALLBACK(_105), this);

  this->p26_clicked = g_signal_connect(this->p26, "clicked", G_CALLBACK(_107), this);

  this->l26_clicked = g_signal_connect(this->l26, "clicked", G_CALLBACK(_109), this);

  this->p27_clicked = g_signal_connect(this->p27, "clicked", G_CALLBACK(_111), this);

  this->l27_clicked = g_signal_connect(this->l27, "clicked", G_CALLBACK(_113), this);

  this->p28_clicked = g_signal_connect(this->p28, "clicked", G_CALLBACK(_115), this);

  this->l28_clicked = g_signal_connect(this->l28, "clicked", G_CALLBACK(_117), this);

  this->p29_clicked = g_signal_connect(this->p29, "clicked", G_CALLBACK(_119), this);

  this->l29_clicked = g_signal_connect(this->l29, "clicked", G_CALLBACK(_121), this);

  this->p30_clicked = g_signal_connect(this->p30, "clicked", G_CALLBACK(_123), this);

  this->l30_clicked = g_signal_connect(this->l30, "clicked", G_CALLBACK(_125), this);

  this->p31_clicked = g_signal_connect(this->p31, "clicked", G_CALLBACK(_127), this);

  this->l31_clicked = g_signal_connect(this->l31, "clicked", G_CALLBACK(_129), this);

  this->p32_clicked = g_signal_connect(this->p32, "clicked", G_CALLBACK(_131), this);

  this->l32_clicked = g_signal_connect(this->l32, "clicked", G_CALLBACK(_133), this);

  this->p33_clicked = g_signal_connect(this->p33, "clicked", G_CALLBACK(_135), this);

  this->l33_clicked = g_signal_connect(this->l33, "clicked", G_CALLBACK(_137), this);

  this->p34_clicked = g_signal_connect(this->p34, "clicked", G_CALLBACK(_139), this);

  this->l34_clicked = g_signal_connect(this->l34, "clicked", G_CALLBACK(_141), this);

  this->p35_clicked = g_signal_connect(this->p35, "clicked", G_CALLBACK(_143), this);

  this->l35_clicked = g_signal_connect(this->l35, "clicked", G_CALLBACK(_145), this);

  this->p36_clicked = g_signal_connect(this->p36, "clicked", G_CALLBACK(_147), this);

  this->l36_clicked = g_signal_connect(this->l36, "clicked", G_CALLBACK(_149), this);

  this->p37_clicked = g_signal_connect(this->p37, "clicked", G_CALLBACK(_151), this);

  this->l37_clicked = g_signal_connect(this->l37, "clicked", G_CALLBACK(_153), this);

  this->p38_clicked = g_signal_connect(this->p38, "clicked", G_CALLBACK(_155), this);

  this->l38_clicked = g_signal_connect(this->l38, "clicked", G_CALLBACK(_157), this);

  this->p39_clicked = g_signal_connect(this->p39, "clicked", G_CALLBACK(_159), this);

  this->l39_clicked = g_signal_connect(this->l39, "clicked", G_CALLBACK(_161), this);

  this->p40_clicked = g_signal_connect(this->p40, "clicked", G_CALLBACK(_163), this);

  this->l40_clicked = g_signal_connect(this->l40, "clicked", G_CALLBACK(_165), this);

  this->p41_clicked = g_signal_connect(this->p41, "clicked", G_CALLBACK(_167), this);

  this->l41_clicked = g_signal_connect(this->l41, "clicked", G_CALLBACK(_169), this);

  this->p42_clicked = g_signal_connect(this->p42, "clicked", G_CALLBACK(_171), this);

  this->l42_clicked = g_signal_connect(this->l42, "clicked", G_CALLBACK(_173), this);

  this->p43_clicked = g_signal_connect(this->p43, "clicked", G_CALLBACK(_175), this);

  this->l43_clicked = g_signal_connect(this->l43, "clicked", G_CALLBACK(_177), this);

  this->p44_clicked = g_signal_connect(this->p44, "clicked", G_CALLBACK(_179), this);

  this->l44_clicked = g_signal_connect(this->l44, "clicked", G_CALLBACK(_181), this);

  this->p45_clicked = g_signal_connect(this->p45, "clicked", G_CALLBACK(_183), this);

  this->l45_clicked = g_signal_connect(this->l45, "clicked", G_CALLBACK(_185), this);

  this->p46_clicked = g_signal_connect(this->p46, "clicked", G_CALLBACK(_187), this);

  this->l46_clicked = g_signal_connect(this->l46, "clicked", G_CALLBACK(_189), this);

  this->p47_clicked = g_signal_connect(this->p47, "clicked", G_CALLBACK(_191), this);

  this->l47_clicked = g_signal_connect(this->l47, "clicked", G_CALLBACK(_193), this);

  this->p48_clicked = g_signal_connect(this->p48, "clicked", G_CALLBACK(_195), this);

  this->l48_clicked = g_signal_connect(this->l48, "clicked", G_CALLBACK(_197), this);

  this->a1f_clicked = g_signal_connect(this->a1f, "clicked", G_CALLBACK(_199), this);

  this->a2f_clicked = g_signal_connect(this->a2f, "clicked", G_CALLBACK(_201), this);

  this->cf_clicked = g_signal_connect(this->cf, "clicked", G_CALLBACK(_203), this);

  this->compute_clicked = g_signal_connect(this->compute, "clicked", G_CALLBACK(_205), this);

  this->save_clicked = g_signal_connect(this->save, "clicked", G_CALLBACK(_207), this);

  this->quit_clicked = g_signal_connect(this->quit, "clicked", G_CALLBACK(_209), this);

  return 0;
}

static void _269(GtkButton *_widget, file_loader *this)
{
  const char *filename;
  GtkWidget *_file = (GtkWidget*)_widget;
  while (GTK_WIDGET_TYPE(_file) != GTK_TYPE_FILE_SELECTION)
    _file = gtk_widget_get_parent(_file);
  filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(_file));
  {_ok(_file, filename);}
}

static void _270(GtkButton *_widget, file_loader *this)
{
  GtkWidget *_file = (GtkWidget*)_widget;
  while (GTK_WIDGET_TYPE(_file) != GTK_TYPE_FILE_SELECTION)
    _file = gtk_widget_get_parent(_file);
  {_cancel(_file);}
}

static gboolean _271(GtkWidget *_widget, GdkEvent *_event, file_loader *this)
{
{gtk_widget_hide(this->f);}
  return TRUE;
}

/* returns -1 on error, 0 if everything is fine */
int init_file_loader(file_loader *this)
{

  this->f = gtk_file_selection_new("choose");



  this->f_ok = g_signal_connect(GTK_FILE_SELECTION(this->f)->ok_button, "clicked", G_CALLBACK(_269), this);
  this->f_cancel = g_signal_connect(GTK_FILE_SELECTION(this->f)->cancel_button, "clicked", G_CALLBACK(_270), this);
  this->f_delete = g_signal_connect(this->f, "delete-event", G_CALLBACK(_271), this);

  return 0;
}

